"""

A script to return country names on the basis of a country code for 4chan/pol/.
This is time-dependent because the flag options changed over time (see https://oilab.eu/mapping-4chan-pol-s-country-flags/).
The results are sometimes guesstimates. For instance, when meme flags and country flags became mixed post-2017,
`TR` could refer to `Tree Hugger` or `Turkey`.

"""

# The static list available from December 2014 and before
first_codes = {
	"AC": "Anarcho-Capitalist",
	"AN": "Anarchist",
	"BL": "Black Nationalist",
	"CF": "Confederate",
	"CM": "Communist",
	"DM": "Democrat",
	"EU": "European",
	"GN": "Gadsden",
	"GY": "Gay",
	"IL": "Israel",
	"JH": "Jihadi",
	"KP": "North Korea",
	"MF": "Muslim",
	"NB": "National Bolshevik",
	"NZ": "Nazi",
	"OB": "Obama",
	"PC": "Hippie",
	"PR": "Pirate",
	"RB": "Rebel",
	"RE": "Republican",
	"RP": "Libertarian",
	"TM": "Templar",
	"TP": "Tea Partier",
	"TR": "Tree Hugger",
	"TX": "Texan",
	"UN": "United Nations",
	"US": "United States",
	"WP": "White Supremacist"
}

# All troll flags
troll_codes = {
	"AC": "Anarcho-Capitalist",
	"AN": "Anarchist",
	"BL": "Black Lives Matter",
	"CF": "Confederate",
	"CT": "Catalonia",
	"CM": "Communist",
	"DM": "Democrat",
	"EU": "European",
	"FC": "Fascist",
	"GN": "Gadsden",
	"GY": "LGBT",
	"JH": "Jihadi",
	"KP": "North Korea",
	"KN": "Kekistani",
	"MF": "Muslim",
	"MZ": "Task Force Z",
	"NB": "National Bolshevik",
	"NT": "NATO",
	"NZ": "Nazi",
	"OB": "Obama",
	"PC": "Hippie",
	"PR": "Pirate",
	"RB": "Rebel",
	"RE": "Republican",
	"RP": "Libertarian",
	"TM": "DEUS VULT",
	"TP": "Tea Partier",
	"TR": "Tree Hugger",
	"TX": "Texan",
	"UN": "United Nations",
	"WP": "White Supremacist"
}

troll_names = ["Anarcho-Capitalist","Anarchist","Black Lives Matter","Black Nationalist","BLM","Confederate","Catalonia","Commie","Communist","Democrat","European","Fascist","Gadsden","Gay","LGBT","Jihadi","North Korea","Kekistani","Muslim","Task Force Z","National Bolshevik","NATO","Nazi","Obama","Hippie","Pirate","Rebel","Republican","Libertarian","Templar","DEUS VULT","Tea Partier","Tree Hugger","Texan","United Nations","White Supremacist"]

country_codes = {
	"A2": "Satellite Provider",
	"AD": "Andorra",
	"AE": "United Arab Emirates",
	"AF": "Afghanistan",
	"AG": "Antigua and Barbuda",
	"AI": "Anguilla",
	"AL": "Albania",
	"AM": "Armenia",
	"AO": "Angola",
	"AP": "Asia/Pacific Region",
	"AQ": "Antarctica",
	"AS": "American Samoa's",
	"AR": "Argentina",
	"AT": "Austria",
	"AU": "Australia",
	"AW": "Aruba",
	"AX": "Aland",
	"AZ": "Azerbaijan",
	"BA": "Bosnia and Herzegovina",
	"BB": "Barbados",
	"BD": "Bangladesh",
	"BE": "Belgium",
	"BF": "Burkina Faso",
	"BG": "Bulgaria",
	"BH": "Bahrain",
	"BI": "Burundi",
	"BJ": "Benin",
	"BL": "Saint Barthélemy",
	"BM": "Bermuda",
	"BN": "Brunei",
	"BO": "Bolivia",
	"BQ": "Bonaire, Sint Eustatius and Saba",
	"BR": "Brazil",
	"BS": "Bahamas",
	"BT": "Bhutan",
	"BV": "Bouvet Island",
	"BW": "Botswana",
	"BY": "Belarus",
	"BZ": "Belize",
	"CA": "Canada",
	"CC": "Cocos (Keeling) Islands",
	"CD": "The Democratic Republic of the Congo",
	"CF": "Central African Republic",
	"CG": "Congo",
	"CH": "Switzerland",
	"CI": "Côte d'Ivoire",
	"CK": "Cook Islands",
	"CL": "Chile",
	"CM": "Cameroon",
	"CN": "China",
	"CO": "Colombia",
	"CR": "Costa Rica",
	"CU": "Cuba",
	"CV": "Cape Verde",
	"CW": "Curaçao",
	"CX": "Christmas Island",
	"CY": "Cyprus",
	"CZ": "Czech Republic",
	"DE": "Germany",
	"DJ": "Djibouti",
	"DK": "Denmark",
	"DM": "Dominica",
	"DO": "Dominican Republic",
	"DZ": "Algeria",
	"EC": "Ecuador",
	"EE": "Estonia",
	"EG": "Egypt",
	"EH": "Western Sahara",
	"ER": "Eritrea",
	"ES": "Spain",
	"ET": "Ethiopia",
	"EU": "European",
	"FI": "Finland",
	"FJ": "Fiji Islands",
	"FK": "Falkland Islands",
	"FM": "Federated States of Micronesia",
	"FO": "Faroe Islands",
	"FR": "France",
	"GA": "Gabon",
	"GB": "United Kingdom",
	"GD": "Grenada",
	"GE": "Georgia",
	"GF": "French Guiana",
	"GG": "Guernsey",
	"GH": "Ghana",
	"GI": "Gibraltar",
	"GL": "Greenland",
	"GM": "Gambia",
	"GN": "Guinea",
	"GP": "Guadeloupe",
	"GQ": "Equatorial Guinea",
	"GR": "Greece",
	"GT": "Guatemala",
	"GU": "Guam",
	"GW": "Guinea-Bissau",
	"GY": "Guyana",
	"HK": "Hong Kong",
	"HN": "Honduras",
	"HR": "Croatia",
	"HT": "Haiti",
	"HU": "Hungary",
	"ID": "Indonesia",
	"IE": "Ireland",
	"IL": "Israel",
	"IM": "Isle of Man",
	"IN": "India",
	"IO": "British Indian Ocean Territory",
	"IQ": "Iraq",
	"IR": "Iran",
	"IS": "Iceland",
	"IT": "Italy",
	"JE": "Jersey",
	"JM": "Jamaica",
	"JO": "Jordan",
	"JP": "Japan",
	"KE": "Kenya",
	"KG": "Kyrgyzstan",
	"KH": "Cambodia",
	"KI": "Kiribati",
	"KM": "Comoros",
	"KN": "Saint Kitts and Nevis",
	"KR": "South Korea",
	"KW": "Kuwait",
	"KY": "Cayman Islands",
	"KZ": "Kazakhstan",
	"LA": "Laos",
	"LB": "Lebanon",
	"LC": "Saint Lucia",
	"LI": "Liechtenstein",
	"LK": "Sri Lanka",
	"LR": "Liberia",
	"LS": "Lesotho",
	"LT": "Lithuania",
	"LU": "Luxembourg",
	"LV": "Latvia",
	"LY": "Libya",
	"MA": "Morocco",
	"MC": "Monaco",
	"MD": "Moldova",
	"ME": "Montenegro",
	"MF": "Saint Martin",
	"MG": "Madagascar",
	"MH": "Marshall Islands",
	"MK": "Macedonia",
	"ML": "Mali",
	"MM": "Myanmar",
	"MN": "Mongolia",
	"MO": "Macao",
	"MP": "Northern Mariana Islands",
	"MQ": "Martinique",
	"MR": "Mauritania",
	"MS": "Montserrat",
	"MT": "Malta",
	"MU": "Mauritius",
	"MV": "Maldives",
	"MW": "Malawi",
	"MX": "Mexico",
	"MY": "Malaysia",
	"MZ": "Mozambique",
	"NA": "Namibia",
	"NC": "New Caledonia",
	"NE": "Niger",
	"NF": "Norfolk Island",
	"NG": "Nigeria",
	"NI": "Nicaragua",
	"NL": "Netherlands",
	"NO": "Norway",
	"NP": "Nepal",
	"NR": "Nauru",
	"NU": "Niue",
	"NZ": "New Zealand",
	"OM": "Oman",
	"PA": "Panama",
	"PE": "Peru",
	"PF": "French Polynesia",
	"PG": "Papua New Guinea",
	"PH": "Philippines",
	"PK": "Pakistan",
	"PL": "Poland",
	"PM": "Saint Pierre and Miquelon",
	"PN": "Pitcairn",
	"PR": "Puerto Rico",
	"PS": "Palestine",
	"PT": "Portugal",
	"PW": "Palau",
	"PY": "Paraguay",
	"QA": "Qatar",
	"RE": "Réunion",
	"RO": "Romania",
	"RS": "Serbia",
	"RU": "Russian Federation",
	"RW": "Rwanda",
	"SA": "Saudi Arabia",
	"SB": "Solomon Islands",
	"SC": "Seychelles",
	"SD": "Sudan",
	"SE": "Sweden",
	"SG": "Singapore",
	"SH": "Saint Helena, Ascension, and Tristan da Cunha",
	"SI": "Slovenia",
	"SJ": "Svalbard and Jan Mayen",
	"SK": "Slovakia",
	"SL": "Sierra Leone",
	"SM": "San Marino",
	"SN": "Senegal",
	"SO": "Somalia",
	"SR": "Suriname",
	"SS": "South Sudan",
	"ST": "Sao Tome and Principe",
	"SV": "El Salvador",
	"SX": "Sint Maarten",
	"SY": "Syria",
	"SZ": "Swaziland",
	"TC": "Turks and Caicos Islands",
	"TD": "Chad",
	"TG": "Togo",
	"TH": "Thailand",
	"TJ": "Tajikistan",
	"TK": "Tokelau",
	"TL": "Timor-Leste",
	"TM": "Turkmenistan",
	"TN": "Tunisia",
	"TO": "Tonga",
	"TR": "Turkey",
	"TT": "Trinidad and Tobago",
	"TV": "Tuvalu",
	"TW": "Taiwan",
	"TZ": "Tanzani",
	"UA": "Ukraine",
	"UG": "Uganda",
	"UM": "United States Minor Outlying Islands",
	"US": "United States",
	"UY": "Uruguay",
	"UZ": "Uzbekistan",
	"VA": "Holy See (Vatican City State)",
	"VC": "Saint Vincent and the Grenadines",
	"VE": "Venezuela",
	"VG": "British Virgin Islands",
	"VI": "Virgin Islands, U.S.",
	"VN": "Vietnam",
	"VU": "Vanuatu",
	"WF": "Wallis and Futuna",
	"WS": "Samoa",
	"XK": "Kosovo",
	"XX": "Unknown",
	"YE": "Yemen",
	"YT": "Mayotte",
	"ZA": "South Africa",
	"ZM": "Zambia",
	"ZW": "Zimbabwe"
}

def get_troll_names():
	return troll_names

def get_country_name(country_code, timestamp, board):
	"""
	:param country_code, str:	The two-letter country code based on ISO 3166-1 alpha-2.
	:param timestamp, int:		Epoch timestamp of the post.

	"""

	# Some conversion
	country_code = country_code.upper()
	timestamp = int(timestamp)

	# If there's a `t_` prepended, this country code is from 4CAT,
	# so we know it's a troll country / meme flag.
	if "T_" in country_code:
		return troll_codes.get(country_code.replace("T_", ""), "")
	
	# /pol/ has some changing flags
	if board == 'pol':
		# Pre-2014 flags were from a static list, so lookup there.
		if timestamp < 1418515200:
			return first_codes.get(country_code, "")

		# After 15 December 2014 and before 13 June 2017, only geoflags were available,
		# so no troll flags, no conflicts.
		elif 1418515200 >= timestamp > 1497312000:
			return country_codes.get(country_code, "")

		# For the merged situation post-2017, we're going to return troll flags for
		# ambiguous ones. These are generally used more often.
		else:
			if country_code in troll_codes:
				return troll_codes[country_code]
			else:
				return country_codes.get(country_code, "")

	else:
		return country_codes.get(country_code, "")